<?php if ( ! defined( 'ABSPATH' ) ) { exit; }

try {
    $sq_environment = Environment::PRODUCTION;
    $apiClient = new SquareClient([
        'environment' => $sq_environment,
        'accessToken' => $this->SQ_Access_Token
    ]);

    $locations_api_response = $apiClient->getLocationsApi()->listLocations();

    if ($locations_api_response->isSuccess()) {
        $locations_result = $locations_api_response->getResult();
        // to string
        $locations_result_json = json_encode($locations_result);
        // to array
        $locations_result_array = json_decode($locations_result_json, true);
        $locations = $locations_result_array['locations'];

        if (count($locations) > 0) {
          $options = array();
          foreach ($locations as $location) {
              $options[ $location['id'] ] = $location['name'] . ' located at ' .
              $location['address']['address_line_1'] . ", " .$location['address']['locality'] . ", " .
              $location['address']['administrative_district_level_1'] . ", " .
              $location['address']['postal_code'] . ", " .
              $location['address']['country'];
            }
            if (empty($this->SQ_Location_Id)) {
                $this->update_option('SQ_Location_Id', $locations[0]['id']);
            }
            $location_id = array(
              'title'       => count($locations) . ' Square Location(s) associated with your merchant account',
              'label'       => 'Select one of your <a href="https://squareup.com/dashboard/locations" target="_blank">Square Locations</a>',
              'description' => 'Select one of your <a href="https://squareup.com/dashboard/locations" target="_blank">Square Locations</a>',
              'type'        => 'select',
              'options'     => $options,
              'default'     => $this->SQ_Location_Id,
              //   'desc_tip'    => true,
            );
        } else {
            $location_id = array(
                'title'       => 'Square Location ID<br>' . $square,
                'type'        => 'text',
                'description' => 'No locations found. Please add a new business location in your <a href="https://squareup.com/dashboard/locations/new" target="_blank">Square Dashboard > Account & Settins Business > Locations</a>',
                'placeholder' => 'LXXXXXXXXXXXX',
            );
        }
    } else {
        $locations_errors = $locations_api_response->getErrors();
        $location_id = array(
            'title'       => 'Square Location ID<br>' . $square,
            'type'        => 'text',
            'description' => $locations_errors . '<br>Get one of your <a href="https://squareup.com/dashboard/locations" target="_blank">Square Locations</a>',
            'placeholder' => 'LXXXXXXXXXXXX',
        );
        // $location_id['default'] = !empty($this->SQ_Location_Id) ? $this->SQ_Location_Id : undefined;
        if ( !empty($this->SQ_Location_Id) ) { $location_id['default'] =$this->SQ_Location_Id; }
    }
} catch (ApiException $e) {
    $location_id = array(
        'title'       => 'Square Location ID<br>' . $square,
        'type'        => 'text',
        'description' => $e . '<br>Get one of your <a href="https://squareup.com/dashboard/locations" target="_blank">Square Locations</a>',
        'placeholder' => 'LXXXXXXXXXXXX',
    );
    // $location_id['default'] =  !empty($this->SQ_Location_Id) ? $this->SQ_Location_Id : undefined;
    if ( !empty($this->SQ_Location_Id) ) { $location_id['default'] = $this->SQ_Location_Id; }
}

?>